
import java.util.*;

class par implements Runnable {

  long y = 0;

  long a (long y) { 
       return(y);
  }

  public void run() { 
      y=a(y++);
  }

}

class parwt implements Runnable {

  long y = 0;

  long a (long y) { 
       return(y);
  }

  public void run() { 
     synchronized(this) { this.notify(); y=a(y++); }
  }

}

class parsr implements Runnable {

  public void run() { 
     Object x;
     for (;;) {
        x = gran.chan.receive();
        if (x instanceof String) break;
     }
  }
}

class parsrs implements Runnable {

  public void run() { 
     Object x;
     for (;;) {
        x = gran.schan.receive();
        if (x instanceof String) break;
     }
  }

}

class parr {

  public static RemoteChannel rchan;

  public static void main( String args[] ) {

     rchan = new RemoteChannel("",-1);
     Object x;
     for (;;) {
        x = rchan.receive();
        if (x instanceof String) break;
     }
     rchan.send(x);

  }

}

class gran {

  static int a (long y) { 
       return( (int) y);
  }

  static void b (long y) { 
       return;
  }

  static long c (long y) { 
       return(y);
  }

  static double factor = -1.0;
  static String blanks = "       ";
  static void time(Date jetzt, Date dann, long iter) {
    double it = (double)iter;
    int t = dann.getSeconds()-jetzt.getSeconds();
    if (t<0) t+=60;
    double f = (double)t/it;
    if (factor <= 0.0) { factor=f; }
    String s = "" + (f/factor+0.05);
    s = s.substring(0,s.indexOf('.')+2);
    s = blanks.substring(0,blanks.length()-s.length()) + s;
    System.out.println("                      " + 
                       " ... seconds: " + t + 
                       ", factor: " + s + "\n");
  }

  public static AsyncChannel  chan;
  public static SyncChannel   schan;
  public static RemoteChannel rchan;

  public static void main( String args[] ) {

  Date jetzt, dann;
  long iter = 10000000;
  long x = 0;
  int p = 7;
  if (args.length == 1) { 
      try { p = Integer.parseInt(args[0]); } 
      catch (NumberFormatException e) { } 
  } 

  switch (p) {

  case 1:
  System.out.println  ("empty loop ...");
  jetzt = new Date(); 
  for(long i=1;i<iter;i++) {
    //     x++;
  }
  dann = new Date(); 
  time(jetzt,dann,iter);

  case 2:
  System.out.println("count loop ...");
  x = 0;
  jetzt = new Date(); 
  for(long i=1;i<iter;i++) {
      x++;
  }
  dann = new Date(); 
  time(jetzt,dann,iter);

  case 3:
  System.out.println("count loop with exception ...");
  x = 0;
  jetzt = new Date(); 
  for(long i=1;i<iter;i++) {
      try { x++;
     } catch (Exception e) { }
  }
  dann = new Date(); 
  time(jetzt,dann,iter);

  case 4:
  System.out.println("empty function loop ...");
  x = 0;
  iter = 8000000;
  jetzt = new Date(); 
  for(long i=1;i<iter;i++) {
      x=c(x++);
  }
  dann = new Date(); 
  time(jetzt,dann,iter);

  case 5:
  System.out.println("empty synchronized loop ...");
  x = 0;
  iter = 2000000;
  jetzt = new Date(); 
  for(long i=1;i<iter;i++) {
    synchronized(jetzt) { x++; }
  }
  dann = new Date(); 
  time(jetzt,dann,iter);

  case 6:
  System.out.println("empty semaphore loop ...");
  x = 0;
  iter = 1000000;
  jetzt = new Date(); 
  sema s = new sema(0);
  for(long i=1;i<iter;i++) {
     s.V(); x++; s.P(); 
  }
  dann = new Date(); 
  time(jetzt,dann,iter);

  case 7:
  System.out.println("empty thread loop ...");
  x = 0;
  iter = 5000;
  Thread t;
  jetzt = new Date(); 
  for(long i=1;i<iter;i++) {
     t = new Thread(new par());
     try { t.start(); t.join();
     } catch (InterruptedException e) { }
  }
  dann = new Date(); 
  time(jetzt,dann,iter);

  case 8:
  System.out.println("synchronized with wait and thread loop ...");
  x = 0;
  iter = 5000;
  jetzt = new Date(); 
  Thread w;
  for(long i=1;i<iter;i++) {
     w = new Thread(new parwt());
     try { w.start(); 
           synchronized(w) { w.wait(); x++; }
           w.join();
     } catch (InterruptedException e) { }
  }
  dann = new Date(); 
  time(jetzt,dann,iter);

  case 9:
  System.out.println("shared memory async send/receive loop ...");
  x = 0;
  iter = 100000;
  jetzt = new Date(); 
  chan = new AsyncChannel(100);
  Thread sr = new Thread(new parsr());
  sr.start(); 
  for(long i=1;i<iter;i++) {
     chan.send(jetzt);
  }
  chan.send("-1");
  try { sr.join();
     } catch (InterruptedException e) { }
  dann = new Date(); 
  time(jetzt,dann,iter);

  case 10:
  System.out.println("shared memory sync send/receive loop ...");
  x = 0;
  iter = 100000;
  jetzt = new Date(); 
  schan = new SyncChannel();
  sr = new Thread(new parsrs());
  sr.start(); 
  for(long i=1;i<iter;i++) {
     schan.send(jetzt);
  }
  schan.send("-1");
  try { sr.join();
     } catch (InterruptedException e) { }
  dann = new Date(); 
  time(jetzt,dann,iter);

  case 11:
  System.out.println("TCP/IP send/receive loop ...");
  x = 0;
  iter = 25000;
  jetzt = new Date(); 
  rchan = new RemoteChannel("localhost",-1);
  for(long i=1;i<iter;i++) {
     rchan.send(jetzt);
  }
  rchan.send("-1");
  Object ox = rchan.receive();
  dann = new Date(); 
  time(jetzt,dann,iter);

  default: 
  }

  System.out.println("x=" + x);

  }


}
